diff --git a/drivers/staging/media/atomisp/i2c/ov2680.h b/drivers/staging/media/atomisp/i2c/ov2680.h
index 45526477b612..54978ff9348c 100644
--- a/drivers/staging/media/atomisp/i2c/ov2680.h
+++ b/drivers/staging/media/atomisp/i2c/ov2680.h
@@ -316,11 +316,11 @@ static struct ov2680_reg const ov2680_QCIF_30fps[] = {
 	{0x4008, 0x00},
 	{0x4009, 0x03},
 	{0x5081, 0x41},
-	{0x5708, 0x00}, //add for full size flip off and mirror off 2014/09/11
-	{0x5704, 0x10},
-	{0x5705, 0xa0},
-	{0x5706, 0x0c},
-	{0x5707, 0x78},
+	{0x5708, 0x01}, //add for full size flip off and mirror off 2014/09/11
+	{0x5704, 0x00},
+	{0x5705, 0xc0},
+	{0x5706, 0x00},
+	{0x5707, 0xa0},
 	{0x3820, 0xc2},
 	{0x3821, 0x01},
 	// {0x5090, 0x0c},
@@ -355,11 +355,11 @@ static struct ov2680_reg const ov2680_CIF_30fps[] = {
 	{0x4008, 0x00},
 	{0x4009, 0x03},
 	{0x5081, 0x41},
-	{0x5708, 0x00}, //add for full size flip off and mirror off 2014/09/11
-	{0x5704, 0x10},
-	{0x5705, 0xa0},
-	{0x5706, 0x0c},
-	{0x5707, 0x78},
+	{0x5708, 0x01}, //add for full size flip off and mirror off 2014/09/11
+	{0x5704, 0x01},
+	{0x5705, 0x70},
+	{0x5706, 0x01},
+	{0x5707, 0x30},
 	{0x3820, 0xc2},
 	{0x3821, 0x01},
 	// {0x5090, 0x0c},
@@ -394,11 +394,11 @@ static struct ov2680_reg const ov2680_QVGA_30fps[] = {
 	{0x4008, 0x00},
 	{0x4009, 0x03},
 	{0x5081, 0x41},
-	{0x5708, 0x00}, //add for full size flip off and mirror off 2014/09/11
-	{0x5704, 0x10},
-	{0x5705, 0xa0},
-	{0x5706, 0x0c},
-	{0x5707, 0x78},
+	{0x5708, 0x01}, //add for full size flip off and mirror off 2014/09/11
+	{0x5704, 0x01},
+	{0x5705, 0x50},
+	{0x5706, 0x01},
+	{0x5707, 0x00},
 	{0x3820, 0xc2},
 	{0x3821, 0x01},
 	// {0x5090, 0x0c},
@@ -433,11 +433,11 @@ static struct ov2680_reg const ov2680_656x496_30fps[] = {
 	{0x4008, 0x00},
 	{0x4009, 0x03},
 	{0x5081, 0x41},
-	{0x5708, 0x00}, //add for full size flip off and mirror off 2014/09/11
-	{0x5704, 0x10},
-	{0x5705, 0xa0},
-	{0x5706, 0x0c},
-	{0x5707, 0x78},
+	{0x5708, 0x01}, //add for full size flip off and mirror off 2014/09/11
+	{0x5704, 0x02},
+	{0x5705, 0x90},
+	{0x5706, 0x01},
+	{0x5707, 0xf0},
 	{0x3820, 0xc2},
 	{0x3821, 0x01},
 	// {0x5090, 0x0c},
@@ -471,7 +471,7 @@ static struct ov2680_reg const ov2680_720x592_30fps[] = {
 	{0x3815, 0x31},
 	{0x4008, 0x00},
 	{0x4009, 0x03},
-	{0x5708, 0x00},
+	{0x5708, 0x01},
 	{0x5704, 0x02},
 	{0x5705, 0xd0}, // X_WIN;
 	{0x5706, 0x02},
@@ -510,7 +510,7 @@ static struct ov2680_reg const ov2680_800x600_30fps[] = {
 	{0x3813, 0x00},
 	{0x3814, 0x31},
 	{0x3815, 0x31},
-	{0x5708, 0x00},
+	{0x5708, 0x01},
 	{0x5704, 0x03},
 	{0x5705, 0x20},
 	{0x5706, 0x02},
@@ -552,11 +552,11 @@ static struct ov2680_reg const ov2680_720p_30fps[] = {
 	{0x4008, 0x02},
 	{0x4009, 0x09},
 	{0x5081, 0x41},
-	{0x5708, 0x00}, //add for full size flip off and mirror off 2014/09/11
-	{0x5704, 0x10},
-	{0x5705, 0xa0},
-	{0x5706, 0x0c},
-	{0x5707, 0x78},
+	{0x5708, 0x01}, //add for full size flip off and mirror off 2014/09/11
+	{0x5704, 0x05},
+	{0x5705, 0x10},
+	{0x5706, 0x02},
+	{0x5707, 0xe0},
 	{0x3820, 0xc0},
 	{0x3821, 0x00},
 	// {0x5090, 0x0c},
@@ -591,11 +591,11 @@ static struct ov2680_reg const ov2680_1296x976_30fps[] = {
 	{0x4008, 0x02},
 	{0x4009, 0x09},
 	{0x5081, 0x41},
-	{0x5708, 0x00}, //add for full size flip off and mirror off 2014/09/11
-	{0x5704, 0x10},
-	{0x5705, 0xa0},
-	{0x5706, 0x0c},
-	{0x5707, 0x78},
+	{0x5708, 0x01}, //add for full size flip off and mirror off 2014/09/11
+	{0x5704, 0x05},
+	{0x5705, 0x10},
+	{0x5706, 0x03},
+	{0x5707, 0xd0},
 	{0x3820, 0xc0},
 	{0x3821, 0x00}, //mirror/flip
 	// {0x5090, 0x0c},
@@ -630,11 +630,11 @@ static struct ov2680_reg const ov2680_1456x1096_30fps[] = {
 	{0x4008, 0x02},
 	{0x4009, 0x09},
 	{0x5081, 0x41},
-	{0x5708, 0x00}, //add for full size flip off and mirror off 2014/09/11
-	{0x5704, 0x10},
-	{0x5705, 0xa0},
-	{0x5706, 0x0c},
-	{0x5707, 0x78},
+	{0x5708, 0x01}, //add for full size flip off and mirror off 2014/09/11
+	{0x5704, 0x05},
+	{0x5705, 0xb0},
+	{0x5706, 0x04},
+	{0x5707, 0x48},
 	{0x3820, 0xc0},
 	{0x3821, 0x00},
 	// {0x5090, 0x0c},
@@ -752,7 +752,7 @@ static struct ov2680_reg const ov2680_1616x1216_30fps[] = {
 	{0x5704, 0x06},
 	{0x5705, 0x50},
 	{0x5706, 0x04},
-	{0x5707, 0xcc},
+	{0x5707, 0xc0},
 	{0x3820, 0xc0},
 	{0x3821, 0x00},
 	// {0x5090, 0x0C},